<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfValidateFieldResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfValidateFieldResult extends AbstractStructArrayBase
{
    /**
     * The ValidateFieldResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\ValidateFieldResult[]
     */
    public $ValidateFieldResult;
    /**
     * Constructor method for ArrayOfValidateFieldResult
     * @uses ArrayOfValidateFieldResult::setValidateFieldResult()
     * @param \RecruitCrm\LogicMelon\StructType\ValidateFieldResult[] $validateFieldResult
     */
    public function __construct(array $validateFieldResult = array())
    {
        $this
            ->setValidateFieldResult($validateFieldResult);
    }
    /**
     * Get ValidateFieldResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult[]|null
     */
    public function getValidateFieldResult()
    {
        return isset($this->ValidateFieldResult) ? $this->ValidateFieldResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setValidateFieldResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setValidateFieldResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateValidateFieldResultForArrayConstraintsFromSetValidateFieldResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfValidateFieldResultValidateFieldResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfValidateFieldResultValidateFieldResultItem instanceof \RecruitCrm\LogicMelon\StructType\ValidateFieldResult) {
                $invalidValues[] = is_object($arrayOfValidateFieldResultValidateFieldResultItem) ? get_class($arrayOfValidateFieldResultValidateFieldResultItem) : sprintf('%s(%s)', gettype($arrayOfValidateFieldResultValidateFieldResultItem), var_export($arrayOfValidateFieldResultValidateFieldResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ValidateFieldResult property can only contain items of type \RecruitCrm\LogicMelon\StructType\ValidateFieldResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ValidateFieldResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\ValidateFieldResult[] $validateFieldResult
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfValidateFieldResult
     */
    public function setValidateFieldResult(array $validateFieldResult = array())
    {
        // validation for constraint: array
        if ('' !== ($validateFieldResultArrayErrorMessage = self::validateValidateFieldResultForArrayConstraintsFromSetValidateFieldResult($validateFieldResult))) {
            throw new \InvalidArgumentException($validateFieldResultArrayErrorMessage, __LINE__);
        }
        if (is_null($validateFieldResult) || (is_array($validateFieldResult) && empty($validateFieldResult))) {
            unset($this->ValidateFieldResult);
        } else {
            $this->ValidateFieldResult = $validateFieldResult;
        }
        return $this;
    }
    /**
     * Add item to ValidateFieldResult value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\ValidateFieldResult $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfValidateFieldResult
     */
    public function addToValidateFieldResult(\RecruitCrm\LogicMelon\StructType\ValidateFieldResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\ValidateFieldResult) {
            throw new \InvalidArgumentException(sprintf('The ValidateFieldResult property can only contain items of type \RecruitCrm\LogicMelon\StructType\ValidateFieldResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ValidateFieldResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\ValidateFieldResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ValidateFieldResult
     */
    public function getAttributeName()
    {
        return 'ValidateFieldResult';
    }
}
